import numpy as NP

def estimationErrorFcn(estimatedStates,estimatedParameters,realStates,realParameters):
    tn = NP.max([estimatedStates.shape[0],realStates.shape[0]])
    tn_diff1 = tn - estimatedStates.shape[0]
    tn_diff2 = tn - realStates.shape[0]
    tn_diff = NP.max([tn_diff1,tn_diff2])
    np = NP.min([estimatedParameters.shape[1],realParameters.shape[1]])
    
    stateError = 0
    parameterError = 0
    
    for i in range(tn-tn_diff):
        stateError += NP.dot((estimatedStates[tn_diff2+i,:]-realStates[tn_diff1+i,:]),(estimatedStates[tn_diff2+i,:]-realStates[tn_diff1+i,:]))
        parameterError += NP.dot((estimatedParameters[tn_diff2+i,:np]-realParameters[tn_diff1+i,:np]),(estimatedParameters[tn_diff2+i,:np]-realParameters[tn_diff1+i,:np]))
    return [(stateError+parameterError),stateError, parameterError]